BaseController('BasePageController',
	{
		alwaysListensTo:['pagebeforeshow','pageshow'],
		defaults:{
			fullPageTemplate:''
		},
		setup: function() {
			this.listensTo = (this.listensTo || []).concat(this.alwaysListensTo);
			this._super.apply(this, arguments);
		}
	},
	{
		init: function() {
			this._super();
			this.processFullPageTemplate();
		},
		processFullPageTemplate: function() {
			if (this.options.fullPageTemplate) {
				this.element.html(this.options.fullPageTemplate, this);
			}
		},
		loadData: function(doneCallback) {
			// this function is called by the Navigation class before the page is changed
			// can be used to load data (or do any other asynchronous actions) before changing to the page
			// when done always call doneCallback(), otherwise the page will not be changed!
			doneCallback();
		},
		customDisplay: function() {
			// if a custom display is needed (such as captureVideo): provide it in this method and return true
			return false;
		},
		pageshow: function() {
			var pageviewPath = this.getPageviewPath();
			if (pageviewPath) {
				l('tracking pageview: ' + pageviewPath);
				TrackingController.trackPageview(pageviewPath);
			}
		},
		getPageviewPath: function() {
			return '/' + this.element.attr('id');
		}
	}
);