﻿BasePageController('HomeController',
	{
		listensTo: ['pagehide']
	},
	{
		pagehide: function() {
			this.element.find('#home-list li').removeClass('active');
		},
		'#home-list li mousedown': function(el) {
			this.element.find('#home-list li').removeClass('active');
			el.addClass('active');
		},
		// voor links naar andere pagina's eerst controleren of er een actief contract is
		ensureActiveContractAndGotoPage: function(pageId, pageData) {
			if (Contract.hasActiveContract()) {
				Navigation.gotoPage(pageId, pageData);
			} else {
				Navigation.gotoPage('contractkeuze', { continueTo: pageId, continueToData: pageData });
			}
		},
		'[data-maf-keuzelink] tap': function(el) {
			this.ensureActiveContractAndGotoPage(el.data('mafKeuzelink'));
			return false;
		},
		'[data-maf-keuzefaq] tap': function(el) {
			this.ensureActiveContractAndGotoPage('faqQuestions', { category: el.data('mafKeuzefaq') });
			return false;
		},
		'[data-maf-keuzesearch] tap': function(el) {
			this.ensureActiveContractAndGotoPage('search', { type: el.data('mafKeuzesearch') });
			return false;
		},
        onBack: function() {
            if (confirm('Wilt u Alphabet Driver afsluiten?')) {
                navigator.app.exitApp();
            }
        }
	}
);