﻿$.Class('Contract',
	{
		contractsChanged: false,
		setContracts: function(contracts) {
			// ervoor zorgen dat er altijd een array met contracten is (door _xmlToObject kan dit ook enkele waarde zijn)
			if (!contracts) {
				contracts = [];
			} else if (!$.isArray(contracts)) {
				contracts = [ contracts ];
			}
			// controleren of er contract is bijgekomen
			var oldContracts = this.getContracts();
			this.contractsChanged = (contracts.length > oldContracts.length);
			// nieuwe contracten bewaren
			window.localStorage.setItem('contracts', JSON.stringify(contracts));
			if (contracts.length == 0) {
				window.localStorage.removeItem('activeContractnummer');
			} else if (contracts.length == 1) {
				this.setActiveContractnummer(contracts[0].contractnummer);
			}
		},
		clearContracts: function() {
			window.localStorage.removeItem('contracts');
			window.localStorage.removeItem('activeContractnummer');
		},
		getContracts: function() {
            var item = window.localStorage.getItem('contracts');
            if (item) {
                return JSON.parse(item);
            } else {
                return [];
            }
			//return JSON.parse(window.localStorage.getItem('contracts')) || [];
		},
		getContractCount: function() {
			return this.getContracts().length;
		},
		hasActiveContract: function() {
			if (this.getContractCount() <= 1) return true;
			if (this.contractsChanged) return false;
			return !!this.getActiveContractnummer();
		},
		getActiveContract: function() {
			var contracts = this.getContracts();
			if (contracts.length == 0) return null;
			if (contracts.length == 1) return contracts[0];
			// eerder geselecteerde contract indien aanwezig
			var activeContractnummer = this.getActiveContractnummer();
			if (activeContractnummer) {
				for (var i = 0; i < contracts.length; i++) {
					if (contracts[i].contractnummer == activeContractnummer) return contracts[i];
				}
			}
			// rijdend contract indien aanwezig
			for (var i = 0; i < contracts.length; i++) {
				if (contracts[i].statuscontract == 'Rijdend') return contracts[i];
			}
			// eerste contract
			return contracts[0];
		},
		getActiveContractnummer: function() {
			return window.localStorage.getItem('activeContractnummer');
		},
		setActiveContractnummer: function(contractnummer) {
			window.localStorage.setItem('activeContractnummer', contractnummer);
            this.contractsChanged = false;
		}
	}, {
	}
);