﻿// jquery extension for getting or setting data-maf attribute
$.fn.maf = function(value) {
	return this.data('maf', value);
};

// jquery selector for the data-maf attribute: example: $('div:maf(bla)') to select div elements with data-maf="bla"
// or $(':maf') to select all elements with a data-maf attribute with any value
$.expr[':'].maf = function(obj, index, meta, stack) {
	var maf = $(obj).maf();
	var arg = meta[3];
	if (arg == null || typeof arg === 'undefined') return (typeof maf !== 'undefined');
	return arg == maf;
};

// jquery selector for the name attribute: example: $('input:name(bla)') to select input elements with name="bla"
// or $(':name') to select all elements with a name attribute with any value
$.expr[':'].name = function(obj, index, meta, stack) {
	var name = $(obj).attr('name');
	var arg = meta[3];
	if (arg == null || typeof arg === 'undefined') return (typeof name !== 'undefined');
	return arg == name;
};

// jquery selector for a property: example: $('a:prop(href="#")') to select all A elements with href="#"
// usefull when attribute value is different than property value
$.expr[':'].prop = function(obj, index, meta, stack) {
	var match = meta[3] && meta[3].match(/([^=]+)=(["'])([^\2]+)\2/);
	return match && obj[match[1]] == match[3];
};

// jquery function to select an element based on it's id, escapes dots and colons if present
$.id = function(id) {
	return $('#' + id.replace(/(:|\.)/g, '\\$1'));
};

$.fn.valueNotDefault = function() {
	var value = this.val();
	if (value == this.prop('defaultValue')) return null;
	return value;
};

// watermark
$.fn.watermark = function() {
	this.each(function() {
		if (this.type === 'password') {
			this.isPasswordType = true;
			this.type = 'text';
		} else {
			this.isPasswordType = false;
		}
	});
	this.focus(function(){
		if (this.value == this.defaultValue){
			this.value = '';
			if (this.isPasswordType) this.type = 'password';
		}
	});
	this.blur(function(){
		if (this.value == ''){
			this.value = this.defaultValue;
			if (this.isPasswordType) this.type = 'text';
		}
	});
	return this;
};

function formatKenteken(kenteken) {
	return kenteken.replace(/([a-z])([0-9])/gi, '$1 - $2').replace(/([0-9])([a-z])/gi, '$1 - $2');
}
