﻿$.Class('User', {
	isLoggedIn: false,
	login: function (username, password, successCallback, errorCallback) {
		var self = this;
		var params = $.extend({ username: username, password: password }, Settings.loginParams);
		$.ajax({
			url: Settings.loginUrl, 
			data: $.param(params),
			type: Settings.loginType,
			dataType: 'xml',
			timeout: Settings.ajaxTimeout,
			success: function(data){
				var obj = self._xmlToObject(data.documentElement);
				//Let op: Server geeft geen duidelijke foutmelding terug of inloggen gelukt is
                //Dus kijk nu of er een auto in het resultaat zit.
				if (obj && obj.auto) {
					// Save login information.
					var loginModel = {
						username: username,
						password: password,
						lastLogin: new Date()
					};
					window.localStorage.setItem('loginData', JSON.stringify(loginModel));
					
					// Save car data.
					Contract.setContracts(obj.auto);
					
					self.isLoggedIn = true;
					successCallback();
				} else {
                    errorCallback('Om gegevens in de Alphabet Driver app te tonen is een geregistreerd leasecontract nodig. Op dit gebruikersID kon deze niet gevonden worden.');
				}
			},
			error: function(xhr, textStatus, errorThrown){
				window.localStorage.removeItem('loginData');
                if ((textStatus) && (textStatus == "parsererror")) {
                    if ((xhr.responseText) && (xhr.responseText.indexOf('unable to login') > -1)) {
                        // Standaard login fout, toon de standaard foutmelding
                        errorCallback();
                    } else {
                        errorCallback("Fout tijdens inloggen. Fleetagent retourneerde een onverwacht antwoord: " + xhr.responseText);
                    }
                } else {
				    errorCallback('Het maken van de verbinding met Fleetagent is mislukt: ' + textStatus);
                }
			}
		});
	},
	// xml to javascript object
	_xmlToObject: function(element) {
		if (element && element.nodeType == element.ELEMENT_NODE) {
			if (element.childNodes.length == 1 && element.childNodes[0].nodeType == element.TEXT_NODE) return element.childNodes[0].nodeValue;
			var result = {};
			for (var i = 0; i < element.childNodes.length; i++) {
				var child = element.childNodes[i];
				var value = this._xmlToObject(child);
				if (value == null) continue;
				if (child.nodeName in result) {
					if (!$.isArray(result[child.nodeName])) {
						var arr = [ result[child.nodeName] ];
						result[child.nodeName] = arr;
					}
					result[child.nodeName].push(value);
				} else {
					result[child.nodeName] = value;
				}
			}
			return result;
		}
		return null;
	},
	logoff: function() {
		this.isLoggedIn = false;
		window.localStorage.removeItem('loginData');
		Contract.clearContracts();
		Navigation.gotoPage('login');
	}
}, {
	init: function() {
		$.error('User class should not be instantiated')
	}
});
